#pragma once

#include "Component.h"
#include "ScriptletContainerFactory.h"
#include "WindowEvent.h"

class CommonUI_QuitAction : public IWindowListener
{
public:

	DECLARE_PROPERTY_CONTAINER(CommonUI_QuitAction)
	CommonUI_QuitAction(void) {}
	~CommonUI_QuitAction(void) {}

	void OnWindowClosing(OUT BOOL* bClose)
	{
		PostQuitMessage(0);
	}
};
class CommonUI_DialogCancelAction
{
public:

	DECLARE_PROPERTY_CONTAINER(CommonUI_DialogCancelAction)
	CommonUI_DialogCancelAction(void) {}
	~CommonUI_DialogCancelAction(void) {}

	void Execute(CComponent* pActionComponent)
	{
		HWND hWndOwner = pActionComponent->GetOwnerWindow();
		::EndDialog(hWndOwner, IDCANCEL);
	}
};
class CommonUI_DialogOkAction
{
public:

	DECLARE_PROPERTY_CONTAINER(CommonUI_DialogOkAction)
	CommonUI_DialogOkAction(void) {}
	~CommonUI_DialogOkAction(void) {}

	void Execute(CComponent* pActionComponent)
	{
		HWND hWndOwner = pActionComponent->GetOwnerWindow();
		::EndDialog(hWndOwner, IDOK);
	}
};
class CommonUI_DialogYesAction
{
public:

	DECLARE_PROPERTY_CONTAINER(CommonUI_DialogYesAction)
	CommonUI_DialogYesAction(void) {}
	~CommonUI_DialogYesAction(void) {}

	void Execute(CComponent* pActionComponent)
	{
		HWND hWndOwner = pActionComponent->GetOwnerWindow();
		::EndDialog(hWndOwner, IDYES);
	}
};
class CommonUI_DialogNoAction
{
public:

	DECLARE_PROPERTY_CONTAINER(CommonUI_DialogNoAction)
	CommonUI_DialogNoAction(void) {}
	~CommonUI_DialogNoAction(void) {}

	void Execute(CComponent* pActionComponent)
	{
		HWND hWndOwner = pActionComponent->GetOwnerWindow();
		::EndDialog(hWndOwner, IDNO);
	}
};
class CommonUI_WindowMinimizeAction
{
public:

	DECLARE_PROPERTY_CONTAINER(CommonUI_WindowMinimizeAction)
	CommonUI_WindowMinimizeAction(void) {}
	~CommonUI_WindowMinimizeAction(void) {}

	void Execute(CComponent* pActionComponent)
	{
		HWND hWndOwner = pActionComponent->GetOwnerWindow();
		::ShowWindow(hWndOwner, SW_MINIMIZE);
	}
};
class CommonUI_WindowMaximizeAction
{
public:

	DECLARE_PROPERTY_CONTAINER(CommonUI_WindowMaximizeAction)
	CommonUI_WindowMaximizeAction(void) {}
	~CommonUI_WindowMaximizeAction(void) {}

	void Execute(CComponent* pActionComponent)
	{
		HWND hWndOwner = pActionComponent->GetOwnerWindow();
		::ShowWindow(hWndOwner, SW_MAXIMIZE);
	}
};
class CommonUI_WindowDestroyAction
{
public:

	DECLARE_PROPERTY_CONTAINER(CommonUI_WindowDestroyAction)
	CommonUI_WindowDestroyAction(void) {}
	~CommonUI_WindowDestroyAction(void) {}

	void Execute(CComponent* pActionComponent)
	{
		HWND hWndOwner = pActionComponent->GetOwnerWindow();
		::DestroyWindow(hWndOwner);
	}
};
class CommonUI_WindowCloseAction
{
public:

	DECLARE_PROPERTY_CONTAINER(CommonUI_WindowCloseAction)
	CommonUI_WindowCloseAction(void) {}
	~CommonUI_WindowCloseAction(void) {}

	void Execute(CComponent* pActionComponent)
	{
		HWND hWndOwner = pActionComponent->GetOwnerWindow();
		SendMessage(hWndOwner, WM_SYSCOMMAND, WPARAM(SC_CLOSE), 0);
	}
};